Description

Cloned from https://bugzilla.redhat.com/show_bug.cgi?id=2277005

When upgrading to Katello 4.11 in a FIPS enabled environment we are seeing issues related to regenerating and reimporting the

candlepin-ca;

2024-04-24 11:22:55 [ERROR ] [configure] /Stage[main]/Certs::Candlepin/Truststore_certificate[/etc

/candlepin/certs/truststore:candlepin-ca]/ensure: change from 'absent' to 'present' failed: Execut

ion of '/bin/keytool -import -v -noprompt -storetype pkcs12 -keystore /etc/candlepin/certs/trustst

ore -alias candlepin-ca -file /etc/candlepin/certs/candlepin-ca.crt -storepass:file /etc/pki/katel

lo/truststore_password-file -J-Dcom.redhat.fips=false' returned 1: keytool error: java.io.IOExcept

ion: keystore password was incorrect

2024-04-24 11:22:55 [ERROR ] [configure] java.io.IOException: keystore password was incorrect

2024-04-24 11:22:55 [ERROR ] [configure] at sun.security.pkcs12.PKCS12KeyStore.engineLoad(PKCS12Ke

yStore.java:2089)

2024-04-24 11:22:55 [ERROR ] [configure] at java.security.KeyStore.load(KeyStore.java:1445)

2024-04-24 11:22:55 [ERROR ] [configure] at sun.security.tools.keytool.Main.doCommands(Main.java:8

39)

2024-04-24 11:22:55 [ERROR ] [configure] at sun.security.tools.keytool.Main.run(Main.java:380)

2024-04-24 11:22:55 [ERROR ] [configure] at sun.security.tools.keytool.Main.main(Main.java:373)

2024-04-24 11:22:55 [ERROR ] [configure] Caused by: java.security.UnrecoverableKeyException: faile

d to decrypt safe contents entry: javax.crypto.BadPaddingException: Given final block not properly

 padded. Such issues can arise if a bad key is used during decryption.

Associated revisions

Revision b9667a02 - 04/25/2024 08:48 AM - Evgeni Golov

Fixes #37384 - properly pass fips=false when checking keystore

In a FIPS-enabled environment, calling `keytool -list` with a wrong

password doesn't yield an error, unless we also pass `fips=false` like

we do when creating the keystore:

1. keytool -list -keystore ./store -storepass wrong-password

Keystore type: PKCS11

Keystore provider: SunPKCS11-NSS-FIPS

Your keystore contains 0 entries
 Passing `fips=false` makes it correctly raise the expected exception:

1. keytool -list -keystore ./store -storepass wrong-password -J-Dcom.redhat.fips=false

keytool error: java.io.IOException: keystore password was incorrect

Fixes: 6fea0bbb4143ca439cff01bf9f0e54cf88140d10

History

#1 - 04/25/2024 08:02 AM - Evgeni Golov

- Subject changed from During upgrade to Katello 4.11 issues are seen with Candlepin keystore

 to During upgrade to Katello 4.11 issues are seen with Candlepin keystore

- Category set to Foreman modules

#2 - 04/25/2024 08:08 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/puppet-certs/pull/444 added

#3 - 04/25/2024 08:19 AM - Evgeni Golov

- Description updated

#4 - 04/25/2024 08:48 AM - The Foreman Bot

- Fixed in Releases 3.11.0 added

#5 - 04/25/2024 08:57 AM - The Foreman Bot

- Pull request https://github.com/theforeman/puppet-certs/pull/445 added

#6 - 04/25/2024 08:59 AM - The Foreman Bot

- Pull request https://github.com/theforeman/puppet-certs/pull/446 added

#7 - 04/25/2024 09:00 AM - Evgeni Golov

- Status changed from Ready For Testing to Closed

Applied in changeset puppet-certs|b9667a02bebf6cce0b96fbd631ce34fb27c325ec.

#8 - 04/25/2024 09:36 AM - Evgeni Golov

- Target version set to 3.9.3

#9 - 04/26/2024 06:46 AM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman-installer/pull/931 added

#10 - 04/26/2024 06:48 AM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman-installer/pull/932 added

#11 - 04/26/2024 02:22 PM - Griffin Sullivan

- Fixed in Releases 3.9.3 added
